package demo;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import java.io.*;
import java.util.Vector;

import biz.wisesoft.util.ftp.*;
import biz.wisesoft.util.mail.*;

public class NetDemo extends JFrame {

	JPanel mainPanel;

	JTabbedPane tabPane;

	SmtpClient smtpclientpanel;

	VerifierClient verifierClient;

	FtpClient ftpclientpanel;

	Pop3Client pop3clientpanel;

	EmailMessage m;

	public NetDemo() {
		super();

		setDefaultCloseOperation(EXIT_ON_CLOSE);

		setTitle("NetSuite Demo");
		m = new EmailMessage();
		try {
			UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
			SwingUtilities.updateComponentTreeUI(this);
		} catch (Exception ex) {
		}
		mainPanel = new JPanel();
		mainPanel.setLayout(new BorderLayout(5, 5));
		smtpclientpanel = new SmtpClient(this);
		verifierClient = new VerifierClient(this);
		ftpclientpanel = new FtpClient(this);
		pop3clientpanel = new Pop3Client(this);
		tabPane = new JTabbedPane();
		tabPane.addTab("SMTPDEMO", smtpclientpanel);
		tabPane.addTab("VERIFYDEMO", verifierClient);
		tabPane.addTab("FTPDEMO", ftpclientpanel);
		tabPane.addTab("POP3DEMO", pop3clientpanel);
		mainPanel.add(tabPane, BorderLayout.CENTER);
		getContentPane().add(mainPanel, BorderLayout.CENTER);

	}

	public static void main(String args[]) {
		NetDemo netdemo = new NetDemo();
		Dimension dim = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
		int preferredWidth = dim.width - ((dim.width * 10) / 100);
		int preferredHeight = dim.height - ((dim.height * 10) / 100) - 12;
		netdemo.setBounds((dim.width - preferredWidth) / 2,
				(dim.height - preferredHeight) / 2, preferredWidth,
				preferredHeight);
		netdemo.show();
	}

}

class SmtpClient extends JPanel implements ActionListener, ItemListener {
	JFrame frame;

	private JPanel northPanel;

	private JLabel hostNameLabel, portLabel, userNameLabel, passwordLabel,
			fromLabel, toLabel, ccLabel, bccLabel, subjectLabel, attachLabel;

	private JTextField hostNameField, portField, userNameField, passwordField,
			fromField, toField, ccField, bccField, subjectField, attachField;

	private JButton attachButton;

	private JLabel authenticationLabel;

	private JCheckBox authenticationCheckBox;

	private JPanel centerPanel;

	private JLabel bodyLabel;

	private JTextArea bodyField;

	private JPanel southPanel;

	private JLabel statusLabel;

	private JTextArea statusField;

	private JButton sendButton;

	private EmailMessage m;

	//	private MIMECompliantMessage message;

	public SmtpClient(JFrame f) {
		super();
		this.setLayout(new BorderLayout(0, 3));
		this.frame = f;

		///////////////////////////////////////////////////////
		this.northPanel = new JPanel();
		GridBagLayout gb = new GridBagLayout();
		this.northPanel.setLayout(gb);
		this.hostNameLabel = new JLabel("SMTP Server Host:");
		this.portLabel = new JLabel("Port:");
		this.authenticationLabel = new JLabel("Authentication allowed?");
		this.userNameLabel = new JLabel("User name:");
		this.passwordLabel = new JLabel("Password:");
		this.fromLabel = new JLabel("From:");
		this.toLabel = new JLabel("To:");
		this.ccLabel = new JLabel("Cc:");
		this.bccLabel = new JLabel("Bcc:");
		this.subjectLabel = new JLabel("Subject:");
		this.attachLabel = new JLabel("Attachments:");
		this.hostNameField = new JTextField(30);
		this.portField = new JTextField(10);
		this.portField.setText("25");
		this.authenticationCheckBox = new JCheckBox("", false);
		this.authenticationCheckBox.addItemListener(this);
		this.userNameField = new JTextField(20);
		this.userNameLabel.setEnabled(false);
		this.userNameField.setEnabled(false);
		this.passwordField = new JTextField(20);
		this.passwordLabel.setEnabled(false);
		this.passwordField.setEnabled(false);
		this.fromField = new JTextField(30);
		this.toField = new JTextField(30);
		this.ccField = new JTextField(30);
		this.bccField = new JTextField(30);
		this.subjectField = new JTextField(30);
		this.attachField = new JTextField(30);
		this.attachButton = new JButton("Browse");
		this.attachButton.setMnemonic('B');
		this.attachButton.addActionListener(this);

		constrain(this.northPanel, this.hostNameLabel, 0, 0, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.hostNameField, 1, 0, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.portLabel, 0, 1, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.portField, 1, 1, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.authenticationLabel, 0, 2, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.authenticationCheckBox, 1, 2, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.userNameLabel, 0, 3, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.userNameField, 1, 3, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.passwordLabel, 0, 4, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.passwordField, 1, 4, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.fromLabel, 0, 5, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.fromField, 1, 5, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.toLabel, 0, 6, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.toField, 1, 6, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.ccLabel, 0, 7, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.ccField, 1, 7, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.bccLabel, 0, 8, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.bccField, 1, 8, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.subjectLabel, 0, 9, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.subjectField, 1, 9, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.attachLabel, 0, 10, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.attachField, 1, 10, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.attachButton, 2, 10, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);

		this.add(this.northPanel, BorderLayout.NORTH);

		///////////////////////////////////////////////////////
		this.centerPanel = new JPanel();
		this.centerPanel.setLayout(new BorderLayout());
		this.bodyLabel = new JLabel("Message Body:");
		this.bodyField = new JTextArea(10, 50);
		this.centerPanel.add(this.bodyLabel, BorderLayout.NORTH);
		this.centerPanel.add(new JScrollPane(this.bodyField),
				BorderLayout.CENTER);
		this.add(this.centerPanel, BorderLayout.CENTER);

		///////////////////////////////////////////////////////
		this.southPanel = new JPanel();
		this.southPanel.setLayout(new BorderLayout());
		this.statusLabel = new JLabel("Status:");
		this.statusField = new JTextArea(5, 50);
		this.statusField.setEditable(false);
		this.sendButton = new JButton("Send Mail");
		this.sendButton.setMnemonic('S');
		this.sendButton.addActionListener(this);
		this.southPanel.add(this.statusLabel, BorderLayout.NORTH);
		this.southPanel.add(new JScrollPane(this.statusField),
				BorderLayout.CENTER);
		this.southPanel.add(this.sendButton, BorderLayout.SOUTH);
		this.add(this.southPanel, BorderLayout.SOUTH);
	}

	public Insets getInsets() {
		return new Insets(5, 5, 5, 5);
	}

	public void constrain(Container container, Component component, int gx,
			int gy, int width, int height, int fill, int anchor, int top,
			int left, int bottom, int right) {
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.gridx = gx;
		gbc.gridy = gy;
		gbc.gridwidth = width;
		gbc.gridheight = height;
		gbc.fill = fill;
		gbc.anchor = anchor;
		gbc.insets = new Insets(top, left, bottom, right);

		((GridBagLayout) container.getLayout()).setConstraints(component, gbc);
		container.add(component);
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == this.attachButton) {
			doAttach();
		} else if (e.getSource() == this.sendButton) {
			try {
				doSend();
			} catch (Exception ex) {
			}
		}
	}

	public void itemStateChanged(ItemEvent e) {
		if (e.getSource() == authenticationCheckBox) {
			boolean flag = authenticationCheckBox.isSelected();
			userNameField.setText("");
			passwordField.setText("");
			userNameLabel.setEnabled(flag);
			userNameField.setEnabled(flag);
			passwordLabel.setEnabled(flag);
			passwordField.setEnabled(flag);
		}
	}

	private void doAttach() {
		JFileChooser dlg = new JFileChooser();
		dlg.setDialogTitle("Select file(s) to attach with mail");
		dlg.setMultiSelectionEnabled(true);
		if (dlg.showOpenDialog(this.frame) == JFileChooser.APPROVE_OPTION) {
			File[] files = dlg.getSelectedFiles();
			String attachStr = new String("");
			for (int i = 0; i < files.length; i++) {
				attachStr += files[i].getPath() + ",";
			}
			if (!attachStr.trim().equals("")) {
				attachStr = attachStr.substring(0, attachStr.length() - 1);
			}
			this.attachField.setText(attachStr);
		}
	}

	private void doSend() throws Exception {
		this.statusField.setText("");

		String host = this.hostNameField.getText();
		if (host == null || host.trim().equals("")) {
			JOptionPane.showMessageDialog(this.frame,
					"Please enter SMTP Server Host.", "Message",
					JOptionPane.ERROR_MESSAGE);
			return;
		}

		String portStr = this.portField.getText();
		if (portStr == null || portStr.trim().equals("")) {
			JOptionPane.showMessageDialog(this.frame, "Please enter Port.",
					"Message", JOptionPane.ERROR_MESSAGE);
			return;
		}
		int port = -1;
		try {
			port = Integer.parseInt(portStr);
		} catch (NumberFormatException nfe) {
			JOptionPane.showMessageDialog(this.frame,
					"Please enter valid numeric value for the Port.",
					"Message", JOptionPane.ERROR_MESSAGE);
			return;
		}
		if (port < 0 || port > 0xFFFF) {
			JOptionPane.showMessageDialog(this.frame,
					"Please enter valid numeric value for the Port.",
					"Message", JOptionPane.ERROR_MESSAGE);
			return;
		}

		boolean authentication = authenticationCheckBox.isSelected();
		String userName = userNameField.getText();
		String password = passwordField.getText();

		String from = this.fromField.getText();
		if (from == null || from.trim().equals("")) {
			JOptionPane.showMessageDialog(this.frame,
					"Please enter From address.", "Message",
					JOptionPane.ERROR_MESSAGE);
			return;
		}

		String to = this.toField.getText();
		if (to == null || to.trim().equals("")) {
			JOptionPane.showMessageDialog(this.frame,
					"Please enter To address.", "Message",
					JOptionPane.ERROR_MESSAGE);
			return;
		}

		String cc = this.ccField.getText();
		if (cc == null) {
			cc = new String("");
		}

		String bcc = this.bccField.getText();
		if (bcc == null) {
			bcc = new String("");
		}

		String subject = this.subjectField.getText();
		if (subject == null) {
			subject = new String("");
		}

		String attach = this.attachField.getText();
		if (attach == null) {
			attach = new String("");
		}

		String body = this.bodyField.getText();
		if (body == null) {
			body = new String("");
		}

		m = new EmailMessage();
		m.from = from;
		m.addRecipient(to);
		m.addCC(cc);
		m.debug = (true);
		m.addBCC(bcc);
		m.subject = subject;
		MsgPart part = new MsgPart();
		part.setData(body, MimeEncoder.QUOTED);
		m.addPart(part);
		m.addFile(new java.io.File(attach));
		m.authUser = userName;
		m.authPwd = password;
		m.autMethod = m.AUTH_LOGIN;
		m.smtpServer = host;
		m.smtpPort = port;
		m.sendMail();

	}

}

class VerifierClient extends JPanel implements ActionListener, ItemListener {
	private JPanel panel;

	private JLabel emailLabel, ifSeverLabel, dnsLabel, resultLabel;

	private JTextField emailText, dnsText;

	private JButton verifyButton;

	private JCheckBox ifServerChoice;

	JFrame frame;

	boolean flag = false;

	Font boldFont = new Font("Dialog", Font.BOLD, 14);

	private Verifier v;

	public VerifierClient(JFrame f) {
		super();
		this.setLayout(new BorderLayout(0, 3));
		this.frame = f;
		this.dnsLabel = new JLabel("Input DNS Name");
		this.emailLabel = new JLabel("Input Email Address:");
		this.ifSeverLabel = new JLabel("Use Server Verify");
		this.resultLabel = new JLabel("Result");
		this.ifServerChoice = new JCheckBox("", false);
		this.ifServerChoice.addItemListener(this);
		this.emailText = new JTextField(20);
		this.dnsText = new JTextField(20);
		this.verifyButton = new JButton("Verify");
		verifyButton.setFont(boldFont);
		verifyButton.setBackground(new Color(200, 240, 148));
		this.verifyButton.addActionListener(this);

		dnsLabel.setBounds(45, 45, 125, 20);
		dnsText.setBounds(180, 45, 100, 20);
		emailLabel.setBounds(45, 80, 125, 20);
		emailText.setBounds(180, 80, 100, 20);
		ifSeverLabel.setBounds(45, 115, 125, 20);
		ifServerChoice.setBounds(180, 115, 125, 20);
		verifyButton.setBounds(135, 185, 100, 20);

		resultLabel.setBounds(135, 145, 100, 20);
		resultLabel.setForeground(Color.red);
		setLayout(null);
		this.add(dnsLabel);
		this.add(dnsText);
		this.add(emailLabel);
		this.add(emailText);
		this.add(ifSeverLabel);
		this.add(ifServerChoice);
		this.add(verifyButton);
		this.add(resultLabel);
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == this.verifyButton) {

			String email = this.emailText.getText();
			if (email == null) {
				email = new String("");
			}
			String dns = this.dnsText.getText();
			if (dns == null) {
				dns = new String("");
			}

			Verifier v = new Verifier(dns, email, flag);
			try {
				boolean tag = v.validateEmailAddress();
				if (tag) {
					resultLabel.setText("Good Email");

				} else {
					resultLabel.setText("Bad Email");
				}
			} catch (Exception er) {
				System.out.println(er.toString());
			}
		}
	}

	public void itemStateChanged(ItemEvent e) {
		if (e.getSource() == ifServerChoice) {
			flag = ifServerChoice.isSelected();

		}
	}

}

class FtpClient extends JPanel implements ActionListener, StatusListener {
	JFrame frame;

	private JPanel fieldsPanel, buttonsPanel, firstSubPanel, firstPanel;

	private JLabel hostLabel, portLabel, userNameLabel, passwordLabel;

	private JTextField hostField, portField, userNameField;

	private JPasswordField passwordField;

	private JButton connectButton, disconnectButton;

	private JPanel secondSubPanel1, secondSubPanel2, secondPanel;

	private JLabel currentPathLabel;

	private JTextField currentPathField;

	private JLabel remoteFileListLabel;

	private JTextArea remoteFileListField;

	private JPanel thirdSubPanel1, thirdSubPanel2, thirdPanel;

	private JLabel statusLabel;

	private JTextArea statusField;

	private JButton cdButton, cdupButton, uploadButton, downloadButton;

	private JButton delButton, renButton, rmdirButton, mkdirButton;

	private FTPClient ftpClient;

	private boolean connected;

	public FtpClient(JFrame f) {
		super();

		this.setLayout(new BorderLayout());

		this.frame = f;
		this.connected = false;

		///////////////////////////////////////////////////////
		fieldsPanel = new JPanel();
		GridBagLayout gb = new GridBagLayout();
		fieldsPanel.setLayout(gb);
		this.hostLabel = new JLabel("FTP Server Host:");
		this.portLabel = new JLabel("Port:");
		this.userNameLabel = new JLabel("User Name:");
		this.passwordLabel = new JLabel("Password:");
		this.hostField = new JTextField(40);
		this.portField = new JTextField(10);
		this.portField.setText("21");
		this.userNameField = new JTextField(40);
		this.passwordField = new JPasswordField(40);
		this.passwordField.setEchoChar('*');
		constrain(fieldsPanel, this.hostLabel, 0, 0, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(fieldsPanel, this.hostField, 1, 0, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(fieldsPanel, this.portLabel, 0, 1, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(fieldsPanel, this.portField, 1, 1, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(fieldsPanel, this.userNameLabel, 0, 2, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(fieldsPanel, this.userNameField, 1, 2, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(fieldsPanel, this.passwordLabel, 0, 3, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(fieldsPanel, this.passwordField, 1, 3, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		buttonsPanel = new JPanel();
		buttonsPanel.setLayout(new GridLayout(2, 1));
		this.connectButton = new JButton("Connect");
		this.connectButton.addActionListener(this);
		this.disconnectButton = new JButton("Disconnect");
		this.disconnectButton.addActionListener(this);
		buttonsPanel.add(connectButton);
		buttonsPanel.add(disconnectButton);
		firstSubPanel = new JPanel();
		firstSubPanel.setLayout(new BorderLayout());
		firstSubPanel.add(fieldsPanel, BorderLayout.WEST);
		firstSubPanel.add(buttonsPanel, BorderLayout.CENTER);
		this.firstPanel = new JPanel();
		this.firstPanel.setLayout(new BorderLayout());
		this.firstPanel.add(firstSubPanel, BorderLayout.CENTER);
		this.add(this.firstPanel, BorderLayout.NORTH);

		///////////////////////////////////////////////////////
		this.secondSubPanel1 = new JPanel();
		this.secondSubPanel1.setLayout(new BorderLayout());
		this.currentPathLabel = new JLabel("Current Path:");
		this.currentPathField = new JTextField();
		this.currentPathField.setEditable(false);
		this.secondSubPanel1.add(this.currentPathLabel, BorderLayout.NORTH);
		this.secondSubPanel1.add(this.currentPathField, BorderLayout.CENTER);

		this.secondSubPanel2 = new JPanel();
		this.secondSubPanel2.setLayout(new BorderLayout());
		this.remoteFileListLabel = new JLabel("Remote File List:");
		this.remoteFileListField = new JTextArea(5, 50);
		this.remoteFileListField.setEditable(false);
		this.secondSubPanel2.add(this.remoteFileListLabel, BorderLayout.NORTH);
		this.secondSubPanel2.add(new JScrollPane(this.remoteFileListField),
				BorderLayout.CENTER);
		this.secondPanel = new JPanel();
		this.secondPanel.setLayout(new BorderLayout(0, 3));
		this.secondPanel.add(this.secondSubPanel1, BorderLayout.NORTH);
		this.secondPanel.add(this.secondSubPanel2, BorderLayout.CENTER);

		this.add(this.secondPanel, BorderLayout.CENTER);

		///////////////////////////////////////////////////////
		this.thirdSubPanel1 = new JPanel();
		this.thirdSubPanel1.setLayout(new BorderLayout());
		this.statusLabel = new JLabel("Communication Status:");
		this.statusField = new JTextArea(5, 50);
		this.statusField.setEditable(false);
		this.thirdSubPanel1.add(this.statusLabel, BorderLayout.NORTH);
		this.thirdSubPanel1.add(new JScrollPane(this.statusField),
				BorderLayout.CENTER);

		this.thirdSubPanel2 = new JPanel();
		this.thirdSubPanel2.setLayout(new GridLayout(2, 4));
		this.cdButton = new JButton("Change Dir");
		this.cdButton.addActionListener(this);
		this.cdupButton = new JButton("Change To Parent Dir");
		this.cdupButton.addActionListener(this);
		this.uploadButton = new JButton("Upload A Local File");
		this.uploadButton.addActionListener(this);
		this.downloadButton = new JButton("Download A Remote File");
		this.downloadButton.addActionListener(this);
		this.delButton = new JButton("Delete A Remote File");
		this.delButton.addActionListener(this);
		this.renButton = new JButton("Rename A Remote File");
		this.renButton.addActionListener(this);
		this.rmdirButton = new JButton("Remove A Remote Dir");
		this.rmdirButton.addActionListener(this);
		this.mkdirButton = new JButton("Make A New Remote Dir");
		this.mkdirButton.addActionListener(this);
		this.thirdSubPanel2.add(this.cdButton);
		this.thirdSubPanel2.add(this.cdupButton);
		this.thirdSubPanel2.add(this.uploadButton);
		this.thirdSubPanel2.add(this.downloadButton);
		this.thirdSubPanel2.add(this.delButton);
		this.thirdSubPanel2.add(this.renButton);
		this.thirdSubPanel2.add(this.rmdirButton);
		this.thirdSubPanel2.add(this.mkdirButton);
		this.thirdPanel = new JPanel();
		this.thirdPanel.setLayout(new BorderLayout(0, 3));
		this.thirdPanel.add(thirdSubPanel1, BorderLayout.CENTER);
		this.thirdPanel.add(thirdSubPanel2, BorderLayout.SOUTH);

		this.add(thirdPanel, BorderLayout.SOUTH);
	}

	public Insets getInsets() {
		return new Insets(5, 5, 5, 5);
	}

	public void constrain(Container container, Component component, int gx,
			int gy, int width, int height, int fill, int anchor, int top,
			int left, int bottom, int right) {
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.gridx = gx;
		gbc.gridy = gy;
		gbc.gridwidth = width;
		gbc.gridheight = height;
		gbc.fill = fill;
		gbc.anchor = anchor;
		gbc.insets = new Insets(top, left, bottom, right);

		((GridBagLayout) container.getLayout()).setConstraints(component, gbc);
		container.add(component);
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == this.connectButton) {
			doConnect();
		} else if (e.getSource() == this.disconnectButton) {
			doDisconnect();
		} else if (e.getSource() == this.cdButton) {
			doCd();
		} else if (e.getSource() == this.cdupButton) {
			doCdUp();
		} else if (e.getSource() == this.uploadButton) {
			doUpload();
		} else if (e.getSource() == this.downloadButton) {
			doDownload();
		} else if (e.getSource() == this.delButton) {
			doDel();
		} else if (e.getSource() == this.renButton) {
			doRen();
		} else if (e.getSource() == this.rmdirButton) {
			doRmdir();
		} else if (e.getSource() == this.mkdirButton) {
			doMkdir();
		}
	}

	public void statusChanged(StatusEvent e) {
		this.statusField.append(e.getStatus());
	}

	private void doConnect() {
		String host = this.hostField.getText();
		if (host == null || host.trim().equals("")) {
			JOptionPane.showMessageDialog(this.frame,
					"Please enter FTP Server Host.", "Message",
					JOptionPane.ERROR_MESSAGE);
			return;
		}

		String portStr = this.portField.getText();
		if (portStr == null || portStr.trim().equals("")) {
			JOptionPane.showMessageDialog(this.frame, "Please enter Port.",
					"Message", JOptionPane.ERROR_MESSAGE);
			return;
		}
		int port = -1;
		try {
			port = Integer.parseInt(portStr);
		} catch (NumberFormatException nfe) {
			JOptionPane.showMessageDialog(this.frame,
					"Please enter valid numeric value for the Port.",
					"Message", JOptionPane.ERROR_MESSAGE);
			return;
		}
		if (port < 0 || port > 0xFFFF) {
			JOptionPane.showMessageDialog(this.frame,
					"Please enter valid numeric value for the Port.",
					"Message", JOptionPane.ERROR_MESSAGE);
			return;
		}

		String userName = this.userNameField.getText();
		if (userName == null || userName.trim().equals("")) {
			JOptionPane.showMessageDialog(this.frame,
					"Please enter User Name.", "Message",
					JOptionPane.ERROR_MESSAGE);
			return;
		}

		String password = new String(this.passwordField.getPassword());
		if (password == null) {
			password = "";
		}

		if (connected) {
			JOptionPane
					.showMessageDialog(this.frame, "Already connected to host "
							+ this.ftpClient.getHostName(), "Message",
							JOptionPane.ERROR_MESSAGE);
			return;
		}

		this.ftpClient = new FTPClient();
		this.ftpClient.addStatusListener(this);
		this.ftpClient.setHostName(host);
		this.ftpClient.setPort(port);
		this.ftpClient.setUserName(userName);
		this.ftpClient.setPassword(password);

		if (this.ftpClient.connect()) {
			connected = true;
			this.currentPathField.setText(this.ftpClient
					.getCurrentWorkingDirectory());
			this.remoteFileListField.setText(this.ftpClient.getFileList());
		} else {
			connected = false;
		}
	}

	private void doDisconnect() {
		if (connected) {
			this.ftpClient.disconnect();
			this.ftpClient.removeStatusListener(this);
			connected = false;
			this.hostField.setText("");
			this.userNameField.setText("");
			this.passwordField.setText("");
			this.currentPathField.setText("");
			this.remoteFileListField.setText("");
		} else {
			JOptionPane.showMessageDialog(this.frame,
					"Connection does not exist.", "Message",
					JOptionPane.ERROR_MESSAGE);
			return;
		}
	}

	private void doCd() {
		if (!connected) {
			JOptionPane.showMessageDialog(this.frame,
					"Connection does not exist.", "Message",
					JOptionPane.ERROR_MESSAGE);
			return;
		}

		String remotePath = JOptionPane
				.showInputDialog("Enter remote path to change to that directory: ");
		if (remotePath == null || remotePath.trim().equals("")) {
			JOptionPane.showMessageDialog(this.frame,
					"Remote path not specified.", "Message",
					JOptionPane.ERROR_MESSAGE);
			return;
		}

		this.ftpClient.changeWorkingDirectory(remotePath);
		this.currentPathField.setText(this.ftpClient
				.getCurrentWorkingDirectory());
		this.remoteFileListField.setText(this.ftpClient.getFileList());
	}

	private void doCdUp() {
		if (!connected) {
			JOptionPane.showMessageDialog(this.frame,
					"Connection does not exist.", "Message",
					JOptionPane.ERROR_MESSAGE);
			return;
		}

		this.ftpClient.changeToParentDirectory();
		this.currentPathField.setText(this.ftpClient
				.getCurrentWorkingDirectory());
		this.remoteFileListField.setText(this.ftpClient.getFileList());
	}

	private void doUpload() {
		if (!connected) {
			JOptionPane.showMessageDialog(this.frame,
					"Connection does not exist.", "Message",
					JOptionPane.ERROR_MESSAGE);
			return;
		}

		JFileChooser dlg = new JFileChooser();
		dlg.setDialogTitle("Select local file to upload");
		dlg.setMultiSelectionEnabled(false);
		if (dlg.showOpenDialog(this.frame) == JFileChooser.APPROVE_OPTION) {
			String fname = dlg.getSelectedFile().getName();
			String path = dlg.getSelectedFile().getPath();

			this.ftpClient.uploadLocalFile(fname, path);
			this.currentPathField.setText(this.ftpClient
					.getCurrentWorkingDirectory());
			this.remoteFileListField.setText(this.ftpClient.getFileList());
		}
	}

	private void doDownload() {
		if (!connected) {
			JOptionPane.showMessageDialog(this.frame,
					"Connection does not exist.", "Message",
					JOptionPane.ERROR_MESSAGE);
			return;
		}

		Object[] message = {
				new JLabel("Enter path and name of remote file: "),
				new JTextField("", 30),
				new JLabel("Enter path and name of local file :"),
				new JTextField("", 30), };

		int result = JOptionPane.showOptionDialog(this.frame, message,
				"Download a remote file", JOptionPane.OK_CANCEL_OPTION,
				JOptionPane.QUESTION_MESSAGE, null, null, null);
		if (result == JOptionPane.OK_OPTION) {
			String remotePath = ((JTextField) message[1]).getText();
			if (remotePath == null || remotePath.trim().equals("")) {
				JOptionPane.showMessageDialog(this.frame,
						"Remote path not specified.", "Message",
						JOptionPane.ERROR_MESSAGE);
				return;
			}
			String localPath = ((JTextField) message[3]).getText();
			if (localPath == null || localPath.trim().equals("")) {
				JOptionPane.showMessageDialog(this.frame,
						"Local path path not specified.", "Message",
						JOptionPane.ERROR_MESSAGE);
				return;
			}
			this.ftpClient.downloadRemoteFile(remotePath, localPath);
		}
	}

	private void doDel() {
		if (!connected) {
			JOptionPane.showMessageDialog(this.frame,
					"Connection does not exist.", "Message",
					JOptionPane.ERROR_MESSAGE);
			return;
		}

		String remotePath = JOptionPane
				.showInputDialog("Enter path and name of remote file to delete: ");
		if (remotePath == null || remotePath.trim().equals("")) {
			JOptionPane.showMessageDialog(this.frame,
					"Remote path not specified.", "Message",
					JOptionPane.ERROR_MESSAGE);
			return;
		}

		this.ftpClient.deleteRemoteFile(remotePath);
		this.currentPathField.setText(this.ftpClient
				.getCurrentWorkingDirectory());
		this.remoteFileListField.setText(this.ftpClient.getFileList());
	}

	private void doRen() {
		if (!connected) {
			JOptionPane.showMessageDialog(this.frame,
					"Connection does not exist.", "Message",
					JOptionPane.ERROR_MESSAGE);
			return;
		}

		Object[] message = {
				new JLabel("Enter path and name of remote file to rename: "),
				new JTextField("", 30),
				new JLabel("Enter path and new name of remote file: "),
				new JTextField("", 30), };

		int result = JOptionPane.showOptionDialog(this.frame, message,
				"Rename a remote file", JOptionPane.OK_CANCEL_OPTION,
				JOptionPane.QUESTION_MESSAGE, null, null, null);
		if (result == JOptionPane.OK_OPTION) {
			String oldPath = ((JTextField) message[1]).getText();
			if (oldPath == null || oldPath.trim().equals("")) {
				JOptionPane.showMessageDialog(this.frame,
						"Old path not specified.", "Message",
						JOptionPane.ERROR_MESSAGE);
				return;
			}
			String newPath = ((JTextField) message[3]).getText();
			if (newPath == null || newPath.trim().equals("")) {
				JOptionPane.showMessageDialog(this.frame,
						"New path path not specified.", "Message",
						JOptionPane.ERROR_MESSAGE);
				return;
			}
			this.ftpClient.renameRemoteFile(oldPath, newPath);
			this.currentPathField.setText(this.ftpClient
					.getCurrentWorkingDirectory());
			this.remoteFileListField.setText(this.ftpClient.getFileList());
		}
	}

	private void doRmdir() {
		if (!connected) {
			JOptionPane.showMessageDialog(this.frame,
					"Connection does not exist.", "Message",
					JOptionPane.ERROR_MESSAGE);
			return;
		}

		String remotePath = JOptionPane
				.showInputDialog("Enter path and name of remote directory to delete: ");
		if (remotePath == null || remotePath.trim().equals("")) {
			JOptionPane.showMessageDialog(this.frame,
					"Remote path not specified.", "Message",
					JOptionPane.ERROR_MESSAGE);
			return;
		}

		this.ftpClient.removeRemoteDirectory(remotePath);
		this.currentPathField.setText(this.ftpClient
				.getCurrentWorkingDirectory());
		this.remoteFileListField.setText(this.ftpClient.getFileList());
	}

	private void doMkdir() {
		if (!connected) {
			JOptionPane.showMessageDialog(this.frame,
					"Connection does not exist.", "Message",
					JOptionPane.ERROR_MESSAGE);
			return;
		}

		String remotePath = JOptionPane
				.showInputDialog("Enter path and name of new remote directory: ");
		if (remotePath == null || remotePath.trim().equals("")) {
			JOptionPane.showMessageDialog(this.frame,
					"Remote path not specified.", "Message",
					JOptionPane.ERROR_MESSAGE);
			return;
		}

		this.ftpClient.createremoteDirectory(remotePath);
		this.currentPathField.setText(this.ftpClient
				.getCurrentWorkingDirectory());
		this.remoteFileListField.setText(this.ftpClient.getFileList());
	}
}

class Pop3Client extends JPanel implements ActionListener {
	JFrame frame;

	JPanel northPanel;

	JLabel hostNameLabel, portLabel, userNameLabel, passwordLabel, delLabel;

	JTextField hostNameField, portField, userNameField;

	JPasswordField passwordField;

	JPanel centerPanel;

	DefaultTableModel mailHeadersTableModel;

	JTable mailHeadersTable;

	JPanel centerLowerPanel;

	JPanel centerLowerUpperPanel;

	JButton getMailHeadersButton;

	JButton getMailButton;

	JLabel mailStatusLabel;

	JPanel southPanel;

	JLabel statusLabel;

	JTextArea bodyField;


	PopClient pop;

	public Pop3Client(JFrame f) {
		super();
		this.setLayout(new BorderLayout(0, 3));
		this.frame = f;

		///////////////////////////////////////////////////////
		this.northPanel = new JPanel();
		GridBagLayout gb = new GridBagLayout();
		this.northPanel.setLayout(gb);
		this.hostNameLabel = new JLabel("POP3 Server Host:");
		this.portLabel = new JLabel("Port:");
		this.userNameLabel = new JLabel("User Name:");
		this.passwordLabel = new JLabel("Password:");
		this.hostNameField = new JTextField(40);
		this.portField = new JTextField(10);
		this.portField.setText("110");
		this.userNameField = new JTextField(40);
		this.passwordField = new JPasswordField(40);
		this.passwordField.setEchoChar('*');

		constrain(this.northPanel, this.hostNameLabel, 0, 0, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.hostNameField, 1, 0, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.portLabel, 0, 1, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.portField, 1, 1, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.userNameLabel, 0, 2, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.userNameField, 1, 2, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.passwordLabel, 0, 3, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		constrain(this.northPanel, this.passwordField, 1, 3, 1, 1,
				GridBagConstraints.VERTICAL, GridBagConstraints.NORTHWEST, 0,
				0, 0, 0);
		this.add(this.northPanel, BorderLayout.NORTH);

		centerPanel = new JPanel();
		centerPanel.setLayout(new BorderLayout(5, 5));
		mailHeadersTableModel = new DefaultTableModel();
		mailHeadersTableModel.addColumn(new String("No."));
		mailHeadersTableModel.addColumn(new String("Sender"));
		mailHeadersTableModel.addColumn(new String("Subject"));
		mailHeadersTableModel.addColumn(new String("Date"));
		mailHeadersTable = new JTable(mailHeadersTableModel) {
			public boolean isCellEditable(int row, int column) {
				return false;
			}
		};
		mailHeadersTable.getTableHeader().setReorderingAllowed(false);
		mailHeadersTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

		centerLowerPanel = new JPanel();
		centerLowerPanel.setLayout(new BorderLayout(0, 0));

		centerLowerUpperPanel = new JPanel();
		centerLowerUpperPanel
				.setLayout(new FlowLayout(FlowLayout.CENTER, 5, 0));

		getMailHeadersButton = new JButton("     Get Mail Headers     ");
		getMailHeadersButton.setMnemonic('H');
		getMailHeadersButton.addActionListener(this);

		getMailButton = new JButton("     Get Mail     ");
		getMailButton.setMnemonic('M');
		getMailButton.addActionListener(this);

		centerLowerUpperPanel.add(getMailHeadersButton);
		centerLowerUpperPanel.add(getMailButton);

		mailStatusLabel = new JLabel("      ", SwingConstants.CENTER);
		mailStatusLabel.setForeground(Color.red);

		centerLowerPanel.add(centerLowerUpperPanel, BorderLayout.CENTER);
		centerLowerPanel.add(mailStatusLabel, BorderLayout.SOUTH);

		centerPanel.add(new JScrollPane(mailHeadersTable), BorderLayout.CENTER);
		centerPanel.add(centerLowerPanel, BorderLayout.SOUTH);

		this.add(this.centerPanel, BorderLayout.CENTER);
		///////////////////////////////////////////////////////
		this.southPanel = new JPanel();
		this.southPanel.setLayout(new BorderLayout());
		this.statusLabel = new JLabel("Body:");
		this.bodyField = new JTextArea(5, 50);
		this.bodyField.setEditable(false);
		this.southPanel.add(this.statusLabel, BorderLayout.NORTH);
		this.southPanel.add(new JScrollPane(this.bodyField),
				BorderLayout.CENTER);
		this.add(this.southPanel, BorderLayout.SOUTH);
	}

	public Insets getInsets() {
		return new Insets(5, 5, 5, 5);
	}

	public void constrain(Container container, Component component, int gx,
			int gy, int width, int height, int fill, int anchor, int top,
			int left, int bottom, int right) {
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.gridx = gx;
		gbc.gridy = gy;
		gbc.gridwidth = width;
		gbc.gridheight = height;
		gbc.fill = fill;
		gbc.anchor = anchor;
		gbc.insets = new Insets(top, left, bottom, right);

		((GridBagLayout) container.getLayout()).setConstraints(component, gbc);
		container.add(component);
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == this.getMailHeadersButton) {
			
			
			mailHeadersTableModel.setRowCount(0);
			openConnection();
			int noOfMessages = pop.numberMessages;
			int tag=0;
			if(noOfMessages>200)
			tag=200;
			else
				tag=noOfMessages;
			
				
			try
			{
				for(int i = 0; i < tag; i++)
				{
					EmailMessage em=pop.retrieveMsg(i+1);
					
					Vector rowData = new Vector();
			
					MsgPart mp=em.getPart(1);
					
				//	System.out.println(mp.getData());
					rowData.addElement("" + (i + 1));
					rowData.addElement(em.from);
					rowData.addElement(em.subject);
					rowData.addElement(em.smtpDate);
					mailHeadersTableModel.addRow(rowData);
			
				}}
			catch(Exception eee)
			{System.out.println(eee);
			
			}
			finally
			{
				mailStatusLabel.setText("");
				getMailHeadersButton.setEnabled(true);
				getMailButton.setEnabled(true);
				pop.disconnect();
			}
			
		} else if (e.getSource() == this.getMailButton) {
			int selectedMailIndex = mailHeadersTable.getSelectedRow();
			if (selectedMailIndex < 0)
				JOptionPane.showMessageDialog(this.frame,
						"Please select the mail from headers table.",
						"Message", JOptionPane.ERROR_MESSAGE);
			else {
				GetMailUtil getMailThread = new GetMailUtil(this,
						selectedMailIndex + 1);
			}
		}
	}

	void openConnection() {
		this.bodyField.setText("");

		String host = this.hostNameField.getText();
		if (host == null || host.trim().equals("")) {
			JOptionPane.showMessageDialog(this.frame,
					"Please enter POP3 Server Host.", "Message",
					JOptionPane.ERROR_MESSAGE);
			return ;
		}

		String portStr = this.portField.getText();
		if (portStr == null || portStr.trim().equals("")) {
			JOptionPane.showMessageDialog(this.frame, "Please enter Port.",
					"Message", JOptionPane.ERROR_MESSAGE);
			return ;
		}
		int port = -1;
		try {
			port = Integer.parseInt(portStr);
		} catch (NumberFormatException nfe) {
			JOptionPane.showMessageDialog(this.frame,
					"Please enter valid numeric value for the Port.",
					"Message", JOptionPane.ERROR_MESSAGE);
			return ;
		}
		if (port < 0 || port > 0xFFFF) {
			JOptionPane.showMessageDialog(this.frame,
					"Please enter valid numeric value for the Port.",
					"Message", JOptionPane.ERROR_MESSAGE);
			return ;
		}

		String user = this.userNameField.getText();
		if (user == null || user.trim().equals("")) {
			JOptionPane.showMessageDialog(this.frame,
					"Please enter User Name.", "Message",
					JOptionPane.ERROR_MESSAGE);
			return ;
		}

		String password = new String(this.passwordField.getPassword());
		if (password == null || password.trim().equals("")) {
			JOptionPane.showMessageDialog(this.frame, "Please enter Password.",
					"Message", JOptionPane.ERROR_MESSAGE);
			return ;
		}
    /**
		this.pop3Client = new PopServer();
		this.pop3Client.setHostName(host);
		this.pop3Client.setPort(port);
		this.pop3Client.setUserName(user);
		this.pop3Client.setPassword(password);

		this.statusField.setText(this.pop3Client.getStatus());
		
		**/
		pop=new PopClient();
	    pop.connect(host,user,password);
	}
}